//
// vardefs.h
//
// Todo: Redesign Memory Management
//

#define Mlinks          -1
#define Mrechts         WIDTH
#define Moben           -1
#define Munten          HEIGHT
#define EINHEITEN       10

#define MAP_X           100
#define MAP_Y           100
#define TS              20
//TS: Tilesize / Gre der Tiles (20*20)

U1 *TerrainData; U4 TerrainDataSize=0; U4 nTiles; // Daten fr Landschaft (=Hintergrund/Texturen/Tiles)
S2 Karte[MAP_Y][MAP_X];                           // Landschaftsstruktur (=Rohdaten/Map/Daten)
POS YKarte[MAP_Y][MAP_X], XKarte[MAP_Y][MAP_X];   // Enthlt Infos ber Hindernisse (Spezialkarte)
U1 *Terrain;          // Zeiger auf entkompremierte Karte (=riesige Bildschirmkarte, Karte*TerrainData)
S2 FeldX, FeldY;      // Gre der geladenen Karte (= z.B. 128*128)
S2 ScrollX, ScrollY;  //Koordinaten, wie weit die Karte verschoben wurde

char MapFile[50];

// Bentigte Var. fr das Scrollen mit der rechten Maustaste
S2 RightScrollX=0, RightScrollY=0, RightScroll=0, RightScrolled=0;
S2 ScrollSpeed = 4;
U1 ScrollDir=0, NachScroll=0;

// Var. fr den aufziehbaren Rahmen
U1 Rahmen=0;
S2 RahmenX, RahmenY;

// Alles fr die animierte Landschaft
#define ANICOUNT 100
ANITER Animated[ANICOUNT];     // Daten fr anim. Landschaft
S2 AniAnz=0;

// Var. fr die Leute
#define LMAX 100
U1 *LeuteData;
MANN Leute[LMAX];              // Liste fr alle Leute
S2 MAnz=0, FAnz=0;
S2 NextFree=0;

// Geschwindigkeitsregelung
S2 GameSpeed=1, GameDel=0;

// MausVariablen
S2 m_image_start=0, m_image_end=0;
U1 MouseImage=0;  // Die Form des Mauszeigers

// Datenbank fr die Fhigkeiten der einzelnen Einheiten
ABILITY Data[EINHEITEN];

// Hindernis def.
#define Hindernis       96

// Fr die Mnner, um richtig zu laufen
S2 O_ANFANG, U_ANFANG, R_ANFANG, L_ANFANG, MANN_DIV, O_LANG,
   U_LANG, R_LANG, L_LANG,
   LO_ANFANG, LU_ANFANG, RO_ANFANG, RU_ANFANG, LO_LANG, LU_LANG, RO_LANG, RU_LANG,
   ANGRIF_L, ANGRIF_R, ANGRIF_O, ANGRIF_U,
   ANGRIF_LL, ANGRIF_RL, ANGRIF_OL, ANGRIF_UL,
   ANGRIF_LO, ANGRIF_LU, ANGRIF_RO, ANGRIF_RU,
   ANGRIF_LOL, ANGRIF_LUL, ANGRIF_ROL, ANGRIF_RUL,
   FL_ANFANG, FR_ANFANG, FO_ANFANG, FU_ANFANG,    
   S1_ANFANG, S1_LANG, S2_ANFANG, S2_LANG;

// Var. fr den Anfang neuer Sprites
S4 HELI_START;
S4 KAMPF_START;

// Diese Variablen sind fr den Editor-Abschnitt in diesem Programm
#define EDITLENGTH      10
U1 edit=0;
S2 EditSelect = 0;
S2 PartSelect=0, SelectX=10, SelectY=10;

// Explosionen
#define EMAX            200
U1 *ExploseData;
EXPLO Explose[EMAX];
S2 EAnz=0;
S2 ExploseNextFree=0;

// Laser
#define LASERMAX        200
LASER Laser[LASERMAX];
S2 LaserAnz=0;
S2 LaserNextFree=0;

// Laser
#define ROCKETMAX        200
LASER Rocket[LASERMAX];
S2 RocketAnz=0;
S2 RocketNextFree=0;

// Rauch
#define RAUCHMAX        200
U1 *RauchData;
RAUCH Rauch[RAUCHMAX];
S2 RauchAnz=0;
S2 RauchNextFree=0;

//Mauskoordinaten
S2 mx1=0, my1=0, mx=0, my=0;

